/*@java
 @Created by Dmitriy I. Suyasov
 @Date 08.04.2005
 @Time 14:04:51
 */
package dsuyasov.inetDoc.functionality;

import org.w3c.dom.Node;

import java.util.ArrayList;
import java.util.Map;


public class Entity {

    /*@
              
     */
    public static final int DEFAULT_ATTRIBUTE = 0;

    /*@
           
     */
    public String entityName;
    /*@
             
     */
    public ArrayList attributes;
    /*@
          - 
     */
    public String templateFile;
    /*@
           
     */
    public ArrayList rules;

    /*@
         .
         @param xml  - XML-
         @param node  XML-   
     */
    public Entity(XMLProcessor xml, Node node) throws XMLProcessorException {

        try {
            entityName = xml.getEntityName(node);
        } catch (XMLProcessorException e) {
            entityName = "";
        }
        attributes = xml.getEntitiesAtributes(node);
        templateFile = xml.getTemplateName(node);
        if (entityName.length()==0)
            return;
        Node ruleNode = xml.getRuleNode(node);
        ArrayList ruleNodes = xml.getRules(ruleNode);
        Map defMap = xml.getDefs(ruleNode);
        rules = new ArrayList();
        try {
            for (int iLoop = 0; iLoop < ruleNodes.size(); iLoop++)
                rules.add(new Rule(xml, (Node) ruleNodes.get(iLoop), defMap, null));
            for (int iLoop = 0; iLoop < rules.size(); iLoop++)
                ((Rule)rules.get(iLoop)).realizeLinks(rules);
        } catch (Exception e) {
            throw new XMLProcessorException(e.getMessage());
        }
    }

    /*@
             
         @param name  
         @return    
     */
    public boolean hasAttribute(String name) {
        for (int iLoop = 0; iLoop < attributes.size(); iLoop++)
            if (((String)attributes.get(iLoop)).equals(name))
                return true;
        return false;
    }

}