/*@java
 @Created by Dmitriy I. Suyasov
 @Date 18.03.2005
 @Time 16:56:18
 */
package dsuyasov.inetDoc.functionality;

import dsuyasov.inetDoc.main.InetDocConstant;

import java.io.*;
import java.util.logging.Logger;


public class Log {

    /*@
            Log
     */
    private static Log logger;
    /*@
           
     */
    private boolean canLog = true;
    /*@
          
     */
    public String buffer = "";
    /*@
             
     */
    public boolean logToFile = false;
    /*@
             
     */
    public boolean logToScreen = false;

    /*@
           .
         @return    Log
     */
    public static Log getLogger() {
        if (logger == null)
            logger = new Log();
        return logger;
    }

    /*@
         .
     */
    private Log() {
        newLog();
    }

    /*@
            .
     */
    public void newLog() {
        File file = new File(InetDocConstant.LOG_FILE_NAME);
        try {
            if (file.exists())
                file.delete();
            file.createNewFile();
            canLog = true;
        } catch (Exception ioe) {
            canLog = false;
        }
    }

    /*@
           .
     */
    public void killLog() {
        File file = new File(InetDocConstant.LOG_FILE_NAME);
        if (file.exists())
            file.delete();   
    }

    /*@
            .
         @param message 
     */
    private synchronized void logtofile(String message) {
        if (!canLog) return;
        FileOutputStream fos = null;
        try {
             fos = new FileOutputStream(InetDocConstant.LOG_FILE_NAME, true);
        } catch (FileNotFoundException fnfe) {
            File file = new File(InetDocConstant.LOG_FILE_NAME);
            try {
                file.createNewFile();
                fos = new FileOutputStream(InetDocConstant.LOG_FILE_NAME, true);
            } catch (Exception ioe) {
                if (InetDocConstant.DEBUG_MODE) Logger.global.warning("Error while trying to log to file.");
            }
        } finally {
            try {
                fos.write(message.getBytes());
                fos.close();
            } catch (IOException ioe) {
                if (InetDocConstant.DEBUG_MODE) Logger.global.warning("Error while trying to log to file.");
            }
        }
    }

    /*@
            .
         @param message 
     */
    private void logtoscreen(String message) {
        System.out.print(message);
    }

    /*@
            .
         @param message 
     */
    public void out(String message) {
        logtoscreen(message);
    }

    /*@
            .
         @param message 
     */
    public void fileOut(String message) {
        logtofile(message);
    }

    /*@
               .
         @param message 
     */
    public void info(String message) {
        if (InetDocConstant.DEBUG_MODE) {
            logtoscreen(message);
            logtofile(message);
        }
    }

    /*@
           .
         @param message 
     */
    public void error(String message) {
        info("Error: " + message);
    }

    /*@
           .
         @param message 
     */
    public void warning(String message) {
        info("Warning: " + message);
    }

    /*@
           .
         @param message 
     */
    public void event(String message) {
        if (logToFile) logtofile("% "+message+".\n");
        if (logToScreen) logtoscreen("% "+message+".\n");
        if (InetDocConstant.bufferedSaved) buffer += "% "+message+".\n";
    }
    /*@
            .
         @param message 
     */
    public void inputVariable(String message, boolean value) {
        if (logToFile) logtofile("+ "+message+".  - "+((value)?"":"")+".\n");
        if (logToScreen) logtoscreen("+ "+message+".  - "+((value)?"":"")+".\n");
        if (InetDocConstant.bufferedSaved) buffer += "+ "+message+".  - "+((value)?"":"")+".\n";
    }

    /*@
            .
         @param message 
     */
    public void output(String message) {
        if (logToFile) logtofile("* "+message+".\n");
        if (logToScreen) logtoscreen("* "+message+".\n");
        if (InetDocConstant.bufferedSaved) buffer += "* "+message+".\n";
    }

    /*@
            .
         @param message 
     */
    public void automatChangeState(String message) {
        if (logToFile) logtofile("# "+message+".\n");
        if (logToScreen) logtoscreen("# "+message+".\n");
        if (InetDocConstant.bufferedSaved) buffer += "# "+message+".\n";
    }

    /*@
              .
         @param message 
         @param start    
     */
    public void automatWork(String message, boolean start) {
        if (logToFile) logtofile(""+((start)?"{":"}")+message+".\n");
        if (logToScreen) logtoscreen(""+((start)?"{":"}")+message+".\n");
        if (InetDocConstant.bufferedSaved) buffer += ""+((start)?"{":"}")+message+".\n";
    }

    /*@
              .
         @param message 
     */
    public void automat(String message) {
        if (logToFile) logtofile("!"+message+".\n");
        if (logToScreen) logtoscreen("!"+message+".\n");
        if (InetDocConstant.bufferedSaved) buffer += "!"+message+".\n";
    }

}
