/*@java
 @Created by Dmitriy I. Suyasov
 @Date 05.04.2005
 @Time 17:41:52
 */
package dsuyasov.inetDoc.automat;

import dsuyasov.inetDoc.functionality.Entity;
import dsuyasov.inetDoc.main.InetDocError;
import dsuyasov.inetDoc.main.InetDocErrorConstant;
import dsuyasov.inetDoc.functionality.CommonVariables;

import java.util.Map;
import java.util.HashMap;
import java.io.File;
import java.io.FileReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.text.MessageFormat;

public class AutomatHTMLResolver extends Automat {

    /*@
            
    */
    private final String specialSymbolStart = "#@";
    /*@
           
    */
    private final String startRepeat = "repeat#";
    /*@
         -  
    */
    private final String indexRepeat = "repeatIndex";
    /*@
           
    */
    private final String endRepeat = "repeatEnd#";
    /*@
        -  
    */
    private final String attributesSeparator = "#";
    /*@
          
    */
    private final String specialSymbolEnd = ";";
    /*@
            IF
    */
    private final String startIf = "if#";
    /*@
            IF
    */
    private final String endIf = "ifEnd#";

    /*@
              
    */
    private Map attributes;
    /*@
        ,   
    */
    private Entity entity;
    /*@
          
    */
    private String page;
    /*@
            
    */
    private int position = 0;
    /*@
             
    */
    private Automat automat;
    /*@
              
    */
    private int copyNumber;
    /*@
             
    */
    private int repeatIndex;
    /*@
          -  
    */
    private String repeatBloc = "";
    /*@
        ,    .
    */
    private String repeatAttributes = "";

    /*@
        .
        @param automatNumber  
        @param attributes       
        @param entity 
    */
    public AutomatHTMLResolver(int automatNumber, Map attributes, Entity entity) {
        super(automatNumber);
        this.attributes = attributes;
        this.entity = entity;
        this.page = "";
        this.repeatIndex = 0;
    }

    /*@
        .
        @param automatNumber  
        @param attributes       
        @param entity 
        @param text   
    */
    public AutomatHTMLResolver(int automatNumber, Map attributes, Entity entity, String text) {
        super(automatNumber);
        this.attributes = attributes;
        this.entity = entity;
        this.page = text;
        this.repeatIndex = 0;
    }

    /*@
        .
        @param automatNumber  
        @param attributes       
        @param entity 
        @param text   
        @param index       
    */
    public AutomatHTMLResolver(int automatNumber, Map attributes, Entity entity, String text, int index) {
        super(automatNumber);
        this.attributes = attributes;
        this.entity = entity;
        this.page = text;
        this.repeatIndex = index;
    }

    /*@
         .
    */
    protected void initialize() {}

    /*@
         .
        @param event   
    */
    protected synchronized void automat(int event) {
        int y_statePrevious = y_state;
        log.automatWork(" "+automatNumber+"     " + y_state, true);

        switch (y_state) {
            case AutomatHTMLResolverConstant.STATE_0_READ_TEMPLATE:
                if (!x4_fileIsLoaded()) {
                    z0_readTemplate();
                } else
                if (x0_errorFound()) {
                    y_state = AutomatHTMLResolverConstant.STATE_6_END_WORK;
                    log.automatChangeState(" "+automatNumber+"    0   6:  ");
                } else {
                    y_state = AutomatHTMLResolverConstant.STATE_1_PROCESS_REPEAT_BLOCKS;
                    log.automatChangeState(" "+automatNumber+"    0   1:   ");
                }
                break;
            case (AutomatHTMLResolverConstant.STATE_1_PROCESS_REPEAT_BLOCKS):
                if (x1_hasRepeatBlock()) {
                    y_state = AutomatHTMLResolverConstant.STATE_2_MULTIPLY_REPEAT_BLOCKS;
                    z2_getRepeatBloc();
                    z4_removeRepeatBlocFromPage();
                    log.automatChangeState(" "+automatNumber+"    1   2:   ");
                } else {
                    y_state = AutomatHTMLResolverConstant.STATE_4_PROCESS_IF_COMMAND;
                    log.automatChangeState(" "+automatNumber+"    1   4:   IF");
                }
                break;
            case (AutomatHTMLResolverConstant.STATE_2_MULTIPLY_REPEAT_BLOCKS):
                if (x3_hasNewCopy()) {
                    y_state = AutomatHTMLResolverConstant.STATE_3_FILL_TEMPLATE;
                    z3_createAutomat();
                    log.automatChangeState(" "+automatNumber+"    2   3:  ");
                } else {
                    y_state = AutomatHTMLResolverConstant.STATE_1_PROCESS_REPEAT_BLOCKS;
                    log.automatChangeState(" "+automatNumber+"    2   1:   ");
                }
                break;
            case (AutomatHTMLResolverConstant.STATE_3_FILL_TEMPLATE):
                y_state = AutomatHTMLResolverConstant.STATE_2_MULTIPLY_REPEAT_BLOCKS;
                z5_setProcessedBlocToPage();
                log.automatChangeState(" "+automatNumber+"    3   2:   ");
                break;
            case (AutomatHTMLResolverConstant.STATE_4_PROCESS_IF_COMMAND):
                if (x5_templateHasIfCommand()) {
                    if (x6_attributesAvailable()) {
                        z8_killIfCommand();
                    } else {
                        z9_killIfBloc();
                        z8_killIfCommand();
                    }
                } else {
                    y_state = AutomatHTMLResolverConstant.STATE_5_PROCESS_COMMAND;
                    log.automatChangeState(" "+automatNumber+"    4   5:  ");
                }
                break;
            case (AutomatHTMLResolverConstant.STATE_5_PROCESS_COMMAND):
                if (x2_hasTemplateAttribute()) {
                    z6_fillAttribute();
                } else {
                    y_state = AutomatHTMLResolverConstant.STATE_6_END_WORK;
                    log.automatChangeState(" "+automatNumber+"    5   6:  ");
                }
                break;
        }

        if (y_statePrevious != y_state)
            switch (y_state) {
                case (AutomatHTMLResolverConstant.STATE_6_END_WORK):
                    z7_saveDocText();
                    z1_closeAutomat();
                    break;
                case (AutomatHTMLResolverConstant.STATE_3_FILL_TEMPLATE):
                    automat.work();
                    break;
            }
        log.automatWork(" "+automatNumber+"     " + y_state, false);
    }

    // Input variables

    /*@
       
     @return    
     */
    private boolean x0_errorFound() {
        boolean value = false;
        for (int iLoop = 0; iLoop < CommonVariables.getInstance().errors.size(); iLoop++)
            if ((CommonVariables.getInstance().errors.get(iLoop) instanceof InetDocError) &&
                    (((InetDocError)CommonVariables.getInstance().errors.get(iLoop)).getType() == InetDocError.TYPE_ERROR))
                value = true;
        log.inputVariable("x0 -    ", value);
        return value;
    }

    /*@
        ,      
        @return      
    */
    private boolean x1_hasRepeatBlock() {
        boolean value = page.indexOf(specialSymbolStart + startRepeat) >= 0;
        log.inputVariable("x1 -    ", value);
        return value;
    }
    /*@
        ,     
        @return     
    */
    private boolean x2_hasTemplateAttribute() {
        boolean value = page.indexOf(specialSymbolStart) >= 0;
        log.inputVariable("x2 -    ", value);
        return value;
    }
    /*@
        ,       
        @return       
    */
    private boolean x3_hasNewCopy() {
        boolean value = false;
        String repeatAttributesTmp = repeatAttributes;

        while (repeatAttributesTmp.indexOf(attributesSeparator) >= 0) {
            String attribute = repeatAttributesTmp.substring(0, repeatAttributesTmp.indexOf(attributesSeparator));
            if (attributes.get(attribute + ((copyNumber==0)?"":""+copyNumber))!=null)
                value = true;
            repeatAttributesTmp = repeatAttributesTmp.substring(repeatAttributesTmp.indexOf(attributesSeparator)+1);
        }
        if (attributes.get(repeatAttributesTmp + ((copyNumber==0)?"":""+copyNumber))!=null)
            value = true;
        log.inputVariable("x3 -     ", value);
        return value;
    }
    /*@
        ,    
        @return    
    */
    private boolean x4_fileIsLoaded() {
        boolean value = page.length() != 0;
        log.inputVariable("x4 -  ", value);
        return value;
    }
    /*@
        ,     IF
        @return     IF
    */
    private boolean x5_templateHasIfCommand() {
        boolean value = page.indexOf(specialSymbolStart+startIf) >=0;
        log.inputVariable("x5 -    IF", value);
        return value;
    }

    /*@
        ,     
        @return     
    */
    private boolean x6_attributesAvailable() {
        int value = page.indexOf(specialSymbolStart+startIf);
        String attrs = page.substring(value+(specialSymbolStart+startIf).length(), page.indexOf(specialSymbolEnd, value+(specialSymbolStart+startIf).length()));
        while (attrs.indexOf(attributesSeparator) >= 0) {
            String attribute = attrs.substring(0, attrs.indexOf(attributesSeparator));
            attrs = attrs.substring(attrs.indexOf(attributesSeparator)+1);
            if (attributes.get(attribute)!= null) {
                log.inputVariable("x6 -   ", true);
                return true;
            }
        }
        if (attributes.get(attrs)!= null) {
            log.inputVariable("x6 -   ", true);
            return true;
        }
        return false;
    }

    // Output actions

    /*@
            
     */
    private void z0_readTemplate() {
        log.output("z0 -  ");
        File file;
        if (entity == null) {
            page=" ";
            return;
        }
        else file = new File(entity.templateFile);
        FileReader fr;
        char charbuff[] = new char [(int) file.length()];
        try {
            fr = new FileReader(file);
            fr.read(charbuff);
            page = new String(charbuff);
        } catch (FileNotFoundException fnfe) {
            CommonVariables.getInstance().errors.add(new InetDocError(InetDocError.TYPE_ERROR, MessageFormat.format(InetDocErrorConstant.ERROR_FILE_NOT_FOUND + " Stack trace: "+fnfe.getMessage(), new String[] {file.getAbsolutePath()})));
        } catch (IOException ioe) {
            CommonVariables.getInstance().errors.add(new InetDocError(InetDocError.TYPE_ERROR, MessageFormat.format(InetDocErrorConstant.ERROR_WHILE_READ_THE_FILE + " Stack trace: "+ioe.getMessage(), new String[] {file.getAbsolutePath()})));
        }
    }

    /*@
          
     */
    private void z1_closeAutomat() {
        log.output("z1 -    2");
        running = false;
    }

    /*@
          
     */
    private void z2_getRepeatBloc() {
        log.output("z2 -         ");

        copyNumber = 0;

        int startPosition = page.indexOf(specialSymbolStart + startRepeat);
        position = startPosition;
        int endPosition = startPosition + 1;

        endPosition = page.indexOf(specialSymbolEnd, startPosition+1);
        repeatAttributes = page.substring(startPosition + (specialSymbolStart + startRepeat).length(), endPosition);

        startPosition += (specialSymbolStart + startRepeat + repeatAttributes + specialSymbolEnd).length();
        endPosition = page.indexOf(specialSymbolStart + endRepeat + repeatAttributes + specialSymbolEnd, endPosition);
        if (endPosition < 0)
            endPosition = page.length();

        repeatBloc = page.substring(startPosition, endPosition);
    }

    /*@
             
     */
    private void z3_createAutomat() {
        log.output("z3 -      ");

        String repeatAttributesTmp = repeatAttributes;

        Map attributesMap = new HashMap(attributes);

        while (repeatAttributesTmp.indexOf(attributesSeparator) >= 0) {
            String attribute = repeatAttributesTmp.substring(0, repeatAttributesTmp.indexOf(attributesSeparator));
            Object value = attributesMap.get(attribute + ((copyNumber==0)?"":""+copyNumber));
            attributesMap.put(attribute, (value == null)?"":value);
            repeatAttributesTmp = repeatAttributesTmp.substring(repeatAttributesTmp.indexOf(attributesSeparator)+1);
        }
        Object value = attributesMap.get(repeatAttributesTmp + ((copyNumber==0)?"":""+copyNumber));
        attributesMap.put(repeatAttributesTmp, (value == null)?"":value);

        automat = new AutomatHTMLResolver(automatNumber+1, attributesMap, entity, repeatBloc, copyNumber);
    }

    /*@
            
     */
    private void z4_removeRepeatBlocFromPage() {
        log.output("z4 -     ");

        String end = specialSymbolStart + endRepeat + repeatAttributes + specialSymbolEnd;
        int endIndex = page.indexOf(end) + (end).length();
        page = (endIndex>=page.length())?(page.substring(0, position)):(page.substring(0, position) + page.substring(endIndex));
    }

    /*@
             
     */
    private void z5_setProcessedBlocToPage() {
        log.output("z5 -     ");

        String textToAppend = (String) CommonVariables.getInstance().currentDocFile.pop();
        page = page.substring(0, position) + textToAppend + page.substring(position);
        position += textToAppend.length();
        copyNumber++;
    }

    /*@
             
     */
    private void z6_fillAttribute() {
        log.output("z6 -       ");

        // Get attribute name
        int attrPosition = page.indexOf(specialSymbolStart);
        int endPosition = page.indexOf(";", attrPosition + specialSymbolStart.length());
        String attribute = page.substring(attrPosition + specialSymbolStart.length(), endPosition);

        // Get attribute value
        String value;
        if (attribute.equals(indexRepeat)) {
            value = "" + repeatIndex;
        } else {
            value = (String) attributes.get(attribute);
            value = (value == null)?"":value;
        }

        // Replace name with its value in our page
        page = page.substring(0, attrPosition) + value + ((endPosition+1>=page.length())?"":page.substring(endPosition+1));
    }

    /*@
          
     */
    private void z7_saveDocText() {
        log.output("z7 -   ");
        CommonVariables.getInstance().currentDocFile.push(page);
    }

    /*@
              IF
     */
    private void z8_killIfCommand() {
        log.output("z8 -   IF  ");
        int value = page.indexOf(specialSymbolStart+startIf);
        int value2 = page.indexOf(specialSymbolEnd, value);
        int end = page.indexOf(specialSymbolStart+endIf+page.substring(value+(specialSymbolStart+startIf).length(), value2 + 1));
        int endEnd = end + (specialSymbolStart+endIf+page.substring(value+(specialSymbolStart+startIf).length(), value2 + 1)).length();
        if (end>=0)
            page = page.substring(0, end) + ((endEnd >= page.length())?"":page.substring(endEnd));
        page = page.substring(0, value) + ((value2+1 >= page.length())?"":page.substring(value2+1));
    }

    /*@
           IF  
     */
    private void z9_killIfBloc() {
        log.output("z9 -   IF  ");
        int value = page.indexOf(specialSymbolStart+startIf);
        int value2 = page.indexOf(specialSymbolEnd, value);
        int end = page.indexOf(specialSymbolStart+endIf+page.substring(value+(specialSymbolStart+startIf).length(), value2 + 1));
        page = page.substring(0, value2+1) + (((end<0) || (end>=page.length()))?"":page.substring(end));
    }

}
