/*@java
 @Created by Dmitriy I. Suyasov
 @Date 06.04.2005
 @Time 15:07:37
 */
package dsuyasov.inetDoc.automat;

import dsuyasov.inetDoc.functionality.*;
import dsuyasov.inetDoc.main.InetDocError;
import dsuyasov.inetDoc.main.InetDocErrorConstant;
import dsuyasov.inetDoc.main.InetDocConstant;

import java.io.*;
import java.text.MessageFormat;
import java.util.Map;
import java.util.HashMap;
import java.util.ArrayList;


public class AutomatPageDocumentator extends Automat {

    /*@
         ,    
     */
    public static final String TOMAP_FILENAME = "FILE_NAME";
    /*@
         ,     
     */
    public static final String TOMAP_ABSOLUTE_FILENAME = "ABSOLUTE_FILE_NAME";
    /*@
         ,    
     */
    public static final String TOMAP_DOCROOT = "DOCROOT";
    /*@
         ,    
     */
    public static final String TOMAP_SOURCEDIR = "SOURCE_DIR";

    /*@
          
     */
    private Template pageTemplate = null;

    /*@
       ,  
     */
    private String pageName = "";

    /*@
       ,  
     */
    private String page = "";

    /*@
          
     */
    private char symbol = ' ';

    /*@
           
     */
    private Page docPage = new Page();

    /*@
          
     */
    private int position = 0;

    /*@
      
     */
    private Bloc currentEntity = null;

    /*@
      
     */
    private String currentAttribute = "";

    /*@
       
     */
    private String currentValue = "";

    /*@
       
     */
    private Automat fillTemplate;

    /*@
      
    */
    private Map baseMap = new HashMap();

    /*@
      
    */
    private String fileName = "";

    /*@
          
    */
    private ArrayList rules = null;
    /*@
          
    */
    private Rule parentRule = null;
    /*@
              
    */
    private Rule baseRule = null;
    /*@
     .   ,      
     @param automatNumber  
     @param templateNumber  
     @param pageName   
     */
    public AutomatPageDocumentator(int automatNumber, int templateNumber, String pageName) {
        super(automatNumber);
        pageTemplate = (Template) CommonVariables.getInstance().templates.get(templateNumber);
        this.pageName = pageName;
    }

    /*@
      
     */
    public void initialize() {
        z0_readFile();
    }

    /*@
      
     @param event   
     */
    public void automat(int event) {
        int y_previousState = y_state;
        log.automatWork(" "+automatNumber+"     " + y_state, true);

        switch (y_state) {
            case (AutomatPageDocumentatorConstant.STATE_0_READ_FILE):
                if (x0_errorFound()) {
                    y_state = AutomatPageDocumentatorConstant.STATE_6_END_WORK;
                    log.automatChangeState(" "+automatNumber+"    0   6:  ");
                } else {
                    y_state = AutomatPageDocumentatorConstant.STATE_1_OUT_OF_DESCRIPTION_BLOC;
                    z3_initialOutOfBlocState();
                    log.automatChangeState(" "+automatNumber+"    0   1:   ");
                }
                break;
            case (AutomatPageDocumentatorConstant.STATE_1_OUT_OF_DESCRIPTION_BLOC):
                if (x2_fileEndReached()) {
                    y_state = AutomatPageDocumentatorConstant.STATE_4_DOCUMENT_PAGE;
                    z12_initializeTemplateFillings();
                    log.automatChangeState(" "+automatNumber+"    1   4:   ");
                } else if (x1_entityStart()) {
                    y_state = AutomatPageDocumentatorConstant.STATE_3_READ_ATTRIBUTE_VALUE;
                    z5_initialDefaultAttribute();
                    log.automatChangeState(" "+automatNumber+"    1   3:   ");
                } else if (x3_ruleClosed()) {
                    z7_getRuleAttributes();
                    z6_getNewRulesList();
                    z1_getNewSymbol();
                    z4_newEventSymbolCame();
                } else if (x4_ruleRealized()) {
                    z6_getNewRulesList();
                    z1_getNewSymbol();
                    z4_newEventSymbolCame();
                } else {
                    z1_getNewSymbol();
                    z4_newEventSymbolCame();
                }
                break;
            case (AutomatPageDocumentatorConstant.STATE_2_READ_ATTRIBUTE_NAME):
                if (x7_entityEnd()) {
                    y_state = AutomatPageDocumentatorConstant.STATE_1_OUT_OF_DESCRIPTION_BLOC;
                    z12_initialInsideBlocState();
                    log.automatChangeState(" "+automatNumber+"    2   1:   ");
                } else if (x6_atributeValueStart()) {
                    y_state = AutomatPageDocumentatorConstant.STATE_3_READ_ATTRIBUTE_VALUE;
                    log.automatChangeState(" "+automatNumber+"    2   3:   ");
                } else {
                    z9_addSymbolToAttributeName();
                    z1_getNewSymbol();
                    z4_newEventSymbolCame();
                }
                break;
            case (AutomatPageDocumentatorConstant.STATE_3_READ_ATTRIBUTE_VALUE):
                if (x7_entityEnd()) {
                    y_state = AutomatPageDocumentatorConstant.STATE_1_OUT_OF_DESCRIPTION_BLOC;
                    z11_removeLastSymbolsFromAttributeValue();
                    z10_saveNewBlocAttribute();
                    z12_initialInsideBlocState();
                    log.automatChangeState(" "+automatNumber+"    2   1:   ");
                } else if (x5_newAttributeStart()) {
                    y_state = AutomatPageDocumentatorConstant.STATE_2_READ_ATTRIBUTE_NAME;
                    z10_saveNewBlocAttribute();
                    log.automatChangeState(" "+automatNumber+"    3   2:   ");
                } else {
                    z8_addSymbolToAttributeValue();
                    z1_getNewSymbol();
                    z4_newEventSymbolCame();
                }
                break;
            case (AutomatPageDocumentatorConstant.STATE_4_DOCUMENT_PAGE):
                if (x6_hasBlocToOut()) {
                    y_state = AutomatPageDocumentatorConstant.STATE_5_FILL_TEMPLATE;
                    z13_createFillTemplateAutomat();
                    log.automatChangeState(" "+automatNumber+"    5   6:  ");
                } else if (!x7_fillHeadEntity()) {
                    y_state = AutomatPageDocumentatorConstant.STATE_5_FILL_TEMPLATE;
                    z15_createAutomatForHead();
                    log.automatChangeState(" "+automatNumber+"    5   6:  ");
                } else if (!x8_fillBaseTemplate()) {
                    y_state = AutomatPageDocumentatorConstant.STATE_5_FILL_TEMPLATE;
                    z16_createAutomatForBase();
                    log.automatChangeState(" "+automatNumber+"    5   6:  ");
                } else {
                    y_state = AutomatPageDocumentatorConstant.STATE_6_END_WORK;
                    z17_saveDocument();
                    log.automatChangeState(" "+automatNumber+"    5   2:  ");
                }
                break;
            case (AutomatPageDocumentatorConstant.STATE_5_FILL_TEMPLATE):
                y_state = AutomatPageDocumentatorConstant.STATE_4_DOCUMENT_PAGE;
                z14_saveAutomatResult();
                log.automatChangeState(" "+automatNumber+"    6   5:   ");
                break;
        }

        if (y_previousState != y_state)
            switch (y_state) {
                case (AutomatPageDocumentatorConstant.STATE_0_READ_FILE):
                    z0_readFile();
                    break;
                case (AutomatPageDocumentatorConstant.STATE_1_OUT_OF_DESCRIPTION_BLOC):
                    z1_getNewSymbol();
                    z4_newEventSymbolCame();
                    break;
                case (AutomatPageDocumentatorConstant.STATE_2_READ_ATTRIBUTE_NAME):
                    z1_getNewSymbol();
                    z4_newEventSymbolCame();
                    break;
                case (AutomatPageDocumentatorConstant.STATE_3_READ_ATTRIBUTE_VALUE):
                    z1_getNewSymbol();
                    z4_newEventSymbolCame();
                    break;
                case (AutomatPageDocumentatorConstant.STATE_4_DOCUMENT_PAGE):
                    z11_createDocFile();
                    break;
                case (AutomatPageDocumentatorConstant.STATE_5_FILL_TEMPLATE):
                    fillTemplate.work();
                    break;
                case (AutomatPageDocumentatorConstant.STATE_6_END_WORK):
                    z18_saveFileMap();
                    z2_closeAutomat();
                    break;
            }
        log.automatWork(" "+automatNumber+"     " + y_state, false);
    }

    //  

    /*@
       
     @return   
     */
    private boolean x0_errorFound() {
        boolean value = false;
        for (int iLoop = 0; iLoop < CommonVariables.getInstance().errors.size(); iLoop++)
            if ((CommonVariables.getInstance().errors.get(iLoop) instanceof InetDocError) &&
                    (((InetDocError)CommonVariables.getInstance().errors.get(iLoop)).getType() == InetDocError.TYPE_ERROR))
                value = true;
        log.inputVariable("x0 -    ", value);
        return value;
    }

    /*@
     ,    
     @return    
     */
    private boolean x1_entityStart() {
        for (int i=1; i < pageTemplate.entities.size(); i++) {
            Rule rule = pageTemplate.getFirstRule(((Entity)pageTemplate.entities.get(i)).entityName);
            if (rule.automatState() == AutomatRuleProcessorConstant.STATE_1_BEGIN) {
                log.inputVariable("x1 -   ", true);
                return true;
            }
        }
        log.inputVariable("x1 -   ", false);
        return false;
    }

    /*@
        ,    
        @return    
     */
    private boolean x2_fileEndReached() {
        if (page.length() <= position) {
            log.inputVariable("x2 -  ", true);
            return true;
        } else {
            log.inputVariable("x2 -  ", false);
            return false;
        }
    }

    /*@
        ,     
      @return     
    */
    private boolean x3_ruleClosed() {
        if ((parentRule != null) && (parentRule.automatState() == AutomatRuleProcessorConstant.STATE_2_END))
            return true;
        return false;
    }

    /*@
        ,     
      @return     
    */
    private boolean x4_ruleRealized() {
        for (int i = 0; i < rules.size(); i++) {
            Rule rule = (Rule) rules.get(i);
            if (rule.automatState() == AutomatRuleProcessorConstant.STATE_1_BEGIN)
                return true;
        }
        return false;
    }

    /*@
        ,       
      @return       
    */
    private boolean x5_newAttributeStart() {
        return symbol == '@';
    }

    /*@
        ,       
      @return       
    */
    private boolean x6_atributeValueStart() {
        return (Character.isWhitespace(symbol) || Character.isSpaceChar(symbol));
    }

    /*@
           
      @return    
    */
    private boolean x7_entityEnd() {
        Rule rule = pageTemplate.getFirstRule(currentEntity.entity.entityName);
        boolean toReturn = rule.automatState() == AutomatRuleProcessorConstant.STATE_2_END;
        return toReturn;
    }

    /*@
          ,     
        @return   ,     
    */
    private boolean x6_hasBlocToOut() {
        int pos = position;
        boolean value = false;
        String baseEntityName = ((Entity)pageTemplate.entities.get(Template.BASE_ENTITY)).entityName;
        String headEntityName = ((Entity)pageTemplate.entities.get(Template.HEAD_ENTITY)).entityName;

        while ((pos<docPage.blocs.size()) && (((Bloc)docPage.blocs.get(pos)).blocName.equals(baseEntityName) || ((Bloc)docPage.blocs.get(pos)).blocName.equals(headEntityName)))
            pos++;
        if (pos < docPage.blocs.size())
            value = true;
        log.inputVariable("x6 -  ,     ", value);
        return value;
    }

    /*@
        ,      
        @return      
    */
    private boolean x7_fillHeadEntity() {
        boolean value = baseMap.get(((Entity)pageTemplate.entities.get(Template.HEAD_ENTITY)).entityName) != null;
        log.inputVariable("x7 -     ", value);
        return value;
    }

    /*@
        ,     
        @return     
    */
    private boolean x8_fillBaseTemplate() {
        boolean value = !docPage.text.equals("");
        log.inputVariable("x8 -   ", value);
        return value;
    }


    //  

    /*@
           
     */
    private void z0_readFile() {
        log.output("z0 -  ");
        File file = new File(this.pageName);
        FileReader fr;
        char charbuff[] = new char [(int) file.length()];
        try {
            fr = new FileReader(file);
            fr.read(charbuff);
            page = new String(charbuff);
        } catch (FileNotFoundException fnfe) {
            CommonVariables.getInstance().errors.add(new InetDocError(InetDocError.TYPE_ERROR, MessageFormat.format(InetDocErrorConstant.ERROR_FILE_NOT_FOUND + " Stack trace: "+fnfe.getMessage(), new String[] {file.getAbsolutePath()})));
        } catch (IOException ioe) {
            CommonVariables.getInstance().errors.add(new InetDocError(InetDocError.TYPE_ERROR, MessageFormat.format(InetDocErrorConstant.ERROR_WHILE_READ_THE_FILE + " Stack trace: "+ioe.getMessage(), new String[] {file.getAbsolutePath()})));
        }
        pageTemplate.initiateRules();
    }

    /*@
           
     */
    private void z1_getNewSymbol() {
        log.output("z1 -   ");
        symbol = (position>=page.length())?' ':page.charAt(position);
        position++;
    }

    /*@
          
     */
    private void z2_closeAutomat() {
        log.output("z2 -    1");
        running = false;
    }

    /*@
             
     */
    private void z3_initialOutOfBlocState() {
        rules = new ArrayList();
        parentRule = null;
        for (int iLoop = 0; iLoop < pageTemplate.rules.size(); iLoop++)
            ((Rule) pageTemplate.rules.get(iLoop)).parentRuleClosed(0);
    }

    /*@
             
     */
    private void z4_newEventSymbolCame() {
        if (parentRule !=null) {
            Rule currentParent = parentRule.getParent();
            while (currentParent != null) {
                currentParent.newSymbolCame(symbol);
                currentParent = currentParent.getParent();
            }
            parentRule.newSymbolCame(symbol);
        }

        for (int i = 0; i < rules.size(); i++) {
            Rule rule = (Rule) rules.get(i);
            rule.newSymbolCame(symbol);
        }

        if (baseRule != null) {
            Rule currentParent = baseRule.getParent();
            while (currentParent != null) {
                currentParent.newSymbolCame(symbol);
                currentParent = currentParent.getParent();
            }
            baseRule.newSymbolCame(symbol);
            if (baseRule.automatState() == AutomatRuleProcessorConstant.STATE_2_END) {
                for (int i = 0; i < baseRule.getAllRules().size(); i++) {
                    Rule rule = (Rule) baseRule.getAllRules().get(i);
                    rule.parentRuleClosed(baseRule.getBackSteps());
                }
                if (baseRule.getParent() != null) {
                    baseRule = baseRule.getParent();
                } else {
                    baseRule = null;
                }
                return;
            }
        }

        ArrayList baseRuleList;
        if (baseRule == null)
            baseRuleList = pageTemplate.rules;
        else
            baseRuleList = baseRule.getAllRules();
        for (int i = 0; i < baseRuleList.size(); i++) {
            Rule rule = (Rule) baseRuleList.get(i);
            rule.newSymbolCame(symbol);
        }

        for (int i = 0; i < baseRuleList.size(); i++)
            if (((Rule) baseRuleList.get(i)).automatState() == AutomatRuleProcessorConstant.STATE_1_BEGIN) {
                for (int j = 0; j < baseRuleList.size(); j++)
                    if (j != i)
                        ((Rule) baseRuleList.get(j)).parentRuleClosed(0);
                baseRule = (Rule) baseRuleList.get(i);
                for (int j = 0; j < baseRule.getAllRules().size(); j++)
                    ((Rule) baseRule.getAllRules().get(j)).setStack(baseRule.getStack());
                break;
            }
    }

    /*@
               
     */
    private void z5_initialDefaultAttribute() {
        for (int i=1; i < pageTemplate.entities.size(); i++) {
            Rule rule = pageTemplate.getFirstRule(((Entity)pageTemplate.entities.get(i)).entityName);
            if (rule.automatState() == AutomatRuleProcessorConstant.STATE_1_BEGIN) {
                this.currentEntity = new Bloc(docPage, docPage.getNewId(), ((Entity)pageTemplate.entities.get(i)).entityName, pageTemplate);
                docPage.blocs.add(currentEntity);
                break;
            }
        }
        for (int i = 0; i < rules.size(); i++)
            ((Rule)rules.get(i)).parentRuleClosed(0);
        while (parentRule != null) {
            parentRule.parentRuleClosed(0);
            parentRule = parentRule.getParent();
        }
        rules = new ArrayList();
        parentRule = null;
        currentAttribute = (String) currentEntity.entity.attributes.get(Entity.DEFAULT_ATTRIBUTE);
        currentValue = "";
    }

    /*@
              
     */
    private void z6_getNewRulesList() {
        if ((parentRule != null) && (parentRule.automatState() == AutomatRuleProcessorConstant.STATE_2_END)) {
            for (int i = 0; i < rules.size(); i++)
                ((Rule) rules.get(i)).parentRuleClosed(parentRule.getBackSteps());
            if (parentRule.getParent() != null) {
                rules = parentRule.getParent().getAllRules();
                parentRule = parentRule.getParent();
            } else {
                rules = currentEntity.entity.rules;
                parentRule = null;
            }
        } else {
            for (int i = 0; i < rules.size(); i++)
                if (((Rule) rules.get(i)).automatState() == AutomatRuleProcessorConstant.STATE_1_BEGIN) {
                    parentRule = (Rule) rules.get(i);
                    rules = parentRule.getAllRules();
                    for (int j = 0; j < rules.size(); j++)
                        ((Rule) rules.get(j)).setStack(parentRule.getStack());
                    break;
                }
        }
    }

    /*@
           ,  
     */
    private void z7_getRuleAttributes() {
        if (parentRule != null) {
            String name = parentRule.getName();
            if (currentEntity.entity.hasAttribute(name)) {
                int index = 0;
                String res = (String) currentEntity.attributes.get(name+((index==0)?"":(""+index)));
                while ((res!=null) && (res.length() > 0)) {
                    index++;
                    res = (String) currentEntity.attributes.get(name+((index==0)?"":(""+index)));
                }
                String value = parentRule.getRuleResult();
                String separator = parentRule.getSeparator();
                if ((separator != null) && (separator.length()>0)) {
                    int pos = value.indexOf(separator);
                    while (pos>=0) {
                        currentEntity.attributes.put(name+((index==0)?"":(""+index)), value.substring(0, pos));
                        if (pos+1 >= value.length())
                            value = "";
                        else
                            value = value.substring(pos+1);
                        index++;
                        pos = value.indexOf(separator);
                    }
                    if (value.length()>0)
                        currentEntity.attributes.put(name+((index==0)?"":(""+index)), value);
                } else
                    currentEntity.attributes.put(name+((index==0)?"":(""+index)), value);
            }
        }
    }

    /*@
              
     */
    private void z8_addSymbolToAttributeValue() {
        currentValue += symbol;
    }

    /*@
              
     */
    private void z9_addSymbolToAttributeName() {
        currentAttribute += symbol;
    }

    /*@
             ,   
     */
    private void z10_saveNewBlocAttribute() {
        if (currentAttribute.length() <= 0)
            currentAttribute = (String) currentEntity.entity.attributes.get(Entity.DEFAULT_ATTRIBUTE);
        int index = 0;
        String value = (String) currentEntity.attributes.get(currentAttribute + ((index==0)?"":(""+index)));
        while ((value != null) && (value.length()>0)) {
            index++;
            value = (String) currentEntity.attributes.get(currentAttribute + ((index==0)?"":(""+index)));
        }
        currentValue = currentValue.replace('\r', ' ');
        currentValue = currentValue.replace('\n', ' ');
        currentEntity.attributes.put(currentAttribute + ((index==0)?"":(""+index)), currentValue);
        currentValue = "";
        currentAttribute = "";
    }

    /*@
              
     */
    private void z11_removeLastSymbolsFromAttributeValue() {
        int symbolsNumber = pageTemplate.getFirstRule(currentEntity.entity.entityName).getBackSteps() - 1;
        if (currentValue.length() < symbolsNumber)
            currentValue = "";
        else if (symbolsNumber < 0)
            currentValue = currentValue + symbol;
        else
            currentValue = currentValue.substring(0, currentValue.length() - symbolsNumber);
    }

    /*@
            ,    
     */
    private void z12_initialInsideBlocState() {
        parentRule = null;
        rules = currentEntity.entity.rules;
    }

    /*@
           
     */
    private void z11_createDocFile() {
        log.output("z11 -   ");

        CommonVariables cv = CommonVariables.getInstance();
        String dirString = pageName.substring(cv.sourceDirectory.length());
        fileName = InetDocConstant.DESTINATION_DIRECTORY + dirString + ".html";// + File.separator + docPageName;
        String tmpStr = fileName;
        String directoryName = "";
        while (tmpStr.indexOf(File.separator) >= 0) {
            directoryName += (directoryName.length()>0)?File.separator:"";
            directoryName += tmpStr.substring(0, tmpStr.indexOf(File.separator));
            tmpStr = tmpStr.substring(tmpStr.indexOf(File.separator) + File.separator.length());
            File dir = new File(directoryName);
            dir.mkdir();
        }
        File file = new File(fileName);
        try {
            file.createNewFile();
        } catch (IOException ioe) {
            cv.errors.add(new InetDocError(InetDocError.TYPE_ERROR, MessageFormat.format(InetDocErrorConstant.ERROR_CAN_NOT_CREATE_FILE, new String[] {dirString})));
        }
    };

    /*@
              
     */
    private void z12_initializeTemplateFillings() {
        log.output("z12 -      ");
        position = 0;
    }

    /*@
            
     */
    private void z13_createFillTemplateAutomat() {
        log.output("z13 -     ");

        Bloc currentBloc = (Bloc) docPage.blocs.get(position);
        String baseEntityName = ((Entity)pageTemplate.entities.get(Template.BASE_ENTITY)).entityName;
        String headEntityName = ((Entity)pageTemplate.entities.get(Template.HEAD_ENTITY)).entityName;

        while (currentBloc.blocName.equals(baseEntityName) || currentBloc.blocName.equals(headEntityName)) {
            position++;
            currentBloc = (Bloc) docPage.blocs.get(position);
        }

        Entity entity = pageTemplate.getEntity(currentBloc.blocName);

        Map attributesMap = new HashMap();
        for (int iLoop = 0; iLoop < entity.attributes.size(); iLoop++) {
            int attrNumber = 0;
            String value = (String) currentBloc.attributes.get(((String)entity.attributes.get(iLoop)) + ((attrNumber==0)?"":""+attrNumber));
            while (value != null) {
                attributesMap.put(currentBloc.blocName + "@" + ((String)entity.attributes.get(iLoop)) + ((attrNumber==0)?"":""+attrNumber), value);
                attrNumber++;
                value = (String) currentBloc.attributes.get(((String)entity.attributes.get(iLoop)) + ((attrNumber==0)?"":""+attrNumber));
            }
        }

        attributesMap.put(TOMAP_ABSOLUTE_FILENAME, pageName);
        attributesMap.put(TOMAP_FILENAME, pageName.substring((pageName.lastIndexOf(File.separator)>=0)?pageName.lastIndexOf(File.separator)+1:0));
        attributesMap.put(TOMAP_DOCROOT, InetDocConstant.DESTINATION_DIRECTORY);
        attributesMap.put(TOMAP_SOURCEDIR, CommonVariables.getInstance().sourceDirectory);

        fillTemplate = new AutomatHTMLResolver(automatNumber + 1, attributesMap, entity);
    }

    /*@
             
     */
    private void z14_saveAutomatResult() {
        log.output("z14 -   ");

        if (baseMap.get(((Entity)pageTemplate.entities.get(Template.HEAD_ENTITY)).entityName) != null) {
            docPage.text = (String) CommonVariables.getInstance().currentDocFile.pop();
            return;
        }
        String blocNumber = "" + ((baseMap.size() == 0)?"":(""+baseMap.size()));
        String blocName = ((String)((Entity)pageTemplate.entities.get(Template.BASE_ENTITY)).attributes.get(Entity.DEFAULT_ATTRIBUTE)) + blocNumber;
        if ((position >= docPage.blocs.size()) || (((Bloc)docPage.blocs.get(position)).blocName.equals(((Entity)pageTemplate.entities.get(Template.HEAD_ENTITY)).entityName))) {
            blocName = ((Entity)pageTemplate.entities.get(Template.HEAD_ENTITY)).entityName;
            position = docPage.blocs.size();
        }
        baseMap.put(blocName, CommonVariables.getInstance().currentDocFile.pop());
        position++;
    }

    /*@
              
     */
    private void z15_createAutomatForHead() {
        log.output("z15 -       ");

        Bloc currentBloc = null;
        Entity base = (Entity)pageTemplate.entities.get(Template.HEAD_ENTITY);
        for (int iLoop = 0; iLoop < docPage.blocs.size(); iLoop++)
            if (((Bloc) docPage.blocs.get(iLoop)).blocName.equals(base.entityName)) {
                currentBloc = (Bloc) docPage.blocs.get(iLoop);
                position = iLoop;
            }
        if (currentBloc == null) {
            currentBloc = new Bloc(docPage, docPage.getNewId(), base.entityName, pageTemplate);
            currentBloc.attributes.put((String)base.attributes.get(Entity.DEFAULT_ATTRIBUTE), "");
            position = docPage.blocs.size();
        }

        Map attributesMap = new HashMap();
        for (int iLoop = 0; iLoop < base.attributes.size(); iLoop++) {
            int attrNumber = 0;
            String value = (String) currentBloc.attributes.get(((String)base.attributes.get(iLoop)) + ((attrNumber==0)?"":""+attrNumber));
            while (value != null) {
                attributesMap.put(currentBloc.blocName + "@" + ((String)base.attributes.get(iLoop)) + ((attrNumber==0)?"":""+attrNumber), value);
                attrNumber++;
                value = (String) currentBloc.attributes.get(((String)base.attributes.get(iLoop)) + ((attrNumber==0)?"":""+attrNumber));
            }
        }

        attributesMap.put(TOMAP_ABSOLUTE_FILENAME, pageName);
        attributesMap.put(TOMAP_FILENAME, pageName.substring((pageName.lastIndexOf(File.separator)>=0)?pageName.lastIndexOf(File.separator)+1:0));
        attributesMap.put(TOMAP_DOCROOT, InetDocConstant.DESTINATION_DIRECTORY);
        attributesMap.put(TOMAP_SOURCEDIR, CommonVariables.getInstance().sourceDirectory);

        fillTemplate = new AutomatHTMLResolver(automatNumber + 1, attributesMap, base);
    }

    /*@
              
     */
    private void z16_createAutomatForBase() {
        log.output("z16 -      ");
        String pre = (String)((Entity) pageTemplate.entities.get(Template.BASE_ENTITY)).attributes.get(Entity.DEFAULT_ATTRIBUTE);
        int minus = 0;
        for (int iLoop = 0; iLoop < docPage.blocs.size(); iLoop++) {
            Bloc bloc = (Bloc) docPage.blocs.get(iLoop);
            if (bloc.blocName.equals(((Entity)pageTemplate.entities.get(Template.HEAD_ENTITY)).entityName)) {
                minus++;
                for (int iLoop2 = 0; iLoop2 < bloc.entity.attributes.size(); iLoop2++) {
                    String key = (String) bloc.entity.attributes.get(iLoop2);
                    int index = 0;
                    while (bloc.attributes.get(key + ((index==0)?"":""+index)) != null) {
                        String value = (String) bloc.attributes.get(key + ((index==0)?"":""+index));
                        baseMap.put(bloc.blocName+"@"+key + ((index==0)?"":""+index), value);
                        index++;
                    }
                }
            } else
            for (int iLoop2 = 0; iLoop2 < bloc.entity.attributes.size(); iLoop2++) {
                String key = (String) bloc.entity.attributes.get(iLoop2);
                String value = (String) bloc.attributes.get(key);
                baseMap.put(pre+"@"+key + (((iLoop-minus)==0)?"":""+(iLoop-minus)), value);
            }
        }
        CommonVariables cv = CommonVariables.getInstance();

        baseMap.put(TOMAP_ABSOLUTE_FILENAME, cv.doubleDirSeparator(pageName.substring(cv.sourceDirectory.length()+1)));
        baseMap.put(TOMAP_FILENAME, pageName.substring((pageName.lastIndexOf(File.separator)>=0)?pageName.lastIndexOf(File.separator)+1:0));
        baseMap.put(TOMAP_DOCROOT, cv.doubleDirSeparator(InetDocConstant.DESTINATION_DIRECTORY));
        baseMap.put(TOMAP_SOURCEDIR, cv.doubleDirSeparator(CommonVariables.getInstance().sourceDirectory));

        fillTemplate = new AutomatHTMLResolver(automatNumber + 1, baseMap, (Entity) pageTemplate.entities.get(Template.BASE_ENTITY));
    }

    /*@
              
     */
    private void z17_saveDocument() {
        log.output("z17 -   ");

        File file = new File(fileName);
        try {
            FileWriter fw = new FileWriter(file);
            fw.write(docPage.text);
            fw.close();
        }
        catch (Exception e) {

        }
    }

    /*@
              
     */
    private void z18_saveFileMap() {
        log.output("z18 -     ");
        CommonVariables cv = CommonVariables.getInstance();
        Entity entity = (Entity) pageTemplate.entities.get(Template.HEAD_ENTITY);
        for (int i = 0; i < entity.attributes.size(); i++) {
            String attr = (String) entity.attributes.get(i);
            String value = (String) baseMap.get(entity.entityName+"@"+attr);
            int index = 1;
            while (baseMap.get(entity.entityName+"@"+attr+index)!= null)
                value += " " + ((String) baseMap.get(entity.entityName+"@"+attr+(index++)));

            index = 0;
            String res = (String) cv.commonMap.get(attr);
            while ((res!=null) && (res.length()>0))
                res = (String) cv.commonMap.get(attr+(++index));
            if ((value!=null) && (value.length()>0))
                cv.commonMap.put(attr+((index==0)?"":(""+index)), value);
            else
                cv.commonMap.put(attr+((index==0)?"":(""+index)), " ");
        }
        int index = 0;
        String res = (String) cv.commonMap.get(TOMAP_ABSOLUTE_FILENAME);
        while ((res!=null) && (res.length()>0))
            res = (String) cv.commonMap.get(TOMAP_ABSOLUTE_FILENAME+(++index));

        cv.commonMap.put(TOMAP_ABSOLUTE_FILENAME+((index==0)?"":""+index), cv.doubleDirSeparator(pageName.substring(cv.sourceDirectory.length()+1)));
        cv.commonMap.put(TOMAP_FILENAME+((index==0)?"":""+index), pageName.substring((pageName.lastIndexOf(File.separator)>=0)?pageName.lastIndexOf(File.separator)+1:0));

    }

}
