/*@java
 @Created by Dmitriy I. Suyasov
 @Date: 02.06.2005
 @Time: 15:42:23
 */
package dsuyasov.inetDoc.functionality;

public class RuleLink {

    /*@
            -     
    */
    private static final int LINK_BEFORE = 0;
    /*@
            -     
    */
    private static final int LINK_AFTER = 1;
    /*@
            -       
    */
    private static final int LINK_BEFORE_OR_AFTER = 2;

    /*@
             XML -     
    */
    private static final String BEFORE = "before";
    /*@
             XML -     
    */
    private static final String AFTER = "after";
    /*@
             XML -       
    */
    private static final String BEFORE_OR_AFTER = "beforeOrAfter";

    /*@
           
    */
    private int type;
    /*@
        
    */
    private Rule link;

    /*@
        .      
        @param type  
        @param link 
    */
    public RuleLink(int type, Rule link) throws Exception{
        this.type = type;
        if ((type < 0) || (type>2))
            throw new Exception("Unknown relation type.");
        this.link = link;
    }

    /*@
        .      
        @param type   
        @param link 
    */
    public RuleLink(String type, Rule link) throws Exception{
        if (type.equals(BEFORE))
            this.type = LINK_BEFORE;
        else if (type.equals(AFTER))
            this.type = LINK_AFTER;
        else if (type.equals(BEFORE_OR_AFTER))
            this.type = LINK_BEFORE_OR_AFTER;
        else
            throw new Exception("Unknown relation type.");
        this.link = link;
    }

    /*@
           
        @return   
    */
    public Rule getRule() {
        return link;
    }

    /*@
          
        @return  
    */
    public int getType() {
        return type;
    }

    /*@
        ,    
        @param rule 
        @return    
    */
    public boolean isThisRule(Rule rule) {
        return rule.equals(link);
    }
}