/**
 @author Dmitriy I. Suyasov
 @since 24.08.2005 15:42:15
 */
package dsuyasov.inetDoc.rulesZone;

import java.util.ArrayList;

public class RuleSpecial extends Rule {

    private static final String DIGITS = "0123456789";
    private static final String ALPHABET = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_";

    public RuleSpecial(Character ch, int next, int number) throws RuleException {
        super(ch, next, number);
    }

    public boolean proceed(ForwardElement element) {
        increaseTheCounter();
        // Add next if rule can be undone
        results.clear();
        if (this.start.intValue() == 0)
            results.add(new ForwardElement(nextStep.getNext(), element.getText(), element.getResult(), element.getHistory()));
        char ch = ((Character) object).charValue();
        if (element.getText().length() == 0)
            return false;
        boolean result = true;
        char inputChar = element.getText().charAt(element.getText().length() - 1);
        switch (ch) {
            case '.':
                if (inputChar == '\n')
                    result = false;
                break;
            case 'd':
                if (DIGITS.indexOf(inputChar) < 0)
                    return false;
                break;
            case 'D':
                if (DIGITS.indexOf(inputChar) >= 0)
                    return false;
                break;
            case 'w':
                if (ALPHABET.indexOf(inputChar) < 0)
                    return false;
                break;
            case 'W':
                if (ALPHABET.indexOf(inputChar) >= 0)
                    return false;
                break;
            case 's':
                if (inputChar != ' ')
                    return false;
                break;
            case 'S':
                if (inputChar == ' ')
                    return false;
                break;
            default:
                char realChar = Rule.createSpecialChar(ch);
                if (realChar != inputChar)
                    result =  false;
                break;
        }
        if (result) {
            results.clear();
            ArrayList list = new ArrayList();
            if (!counterMore())
                list.add(new ForwardElement(getRuleNumber(), element.getText().substring(0, element.getText().length() - 1), element.getResult(), element.addToHistory(new Object[] {new Integer(Rule.SPECIAL), object, element.getText()})));
            if (!counterLess())
                list.add(new ForwardElement(nextStep.getNext(), element.getText().substring(0, element.getText().length() - 1), element.getResult(), element.addToHistory(new Object[] {new Integer(Rule.SPECIAL), object, element.getText()})));
            results.addAll(list);
            if (this.start.intValue() == 0)
                results.add(new ForwardElement(nextStep.getNext(), element.getText(), element.getResult(), element.getHistory()));
        }
        return result;
    }

    public String getStartPoint() {
        return null;
    }

    public String toString() {
        return "{ SPECIAL [\\"+object.toString()+"] }";
    }

}
