/**
 @author Dmitriy I. Suyasov
 @since 05.09.2005 15:16:00
 */
package dsuyasov.inetDoc.xml;

import java.util.ArrayList;
import java.util.Iterator;

public class Attributes {

    private ArrayList list;

    Attributes() {
        list = new ArrayList();
    }

    public void addAttribute(String name, String value) throws Exception {
        if (getNamedAttribute(name) != null)
            throw new Exception("     ");
        list.add(new AttributeNode(name, value));
    }

    public Node getAttribute(int index) {
        return ((index >= list.size()) || (index < 0))?null:(Node) list.get(index);
    }

    public Node getNamedAttribute(String name) {
        for (Iterator iter = list.iterator(); iter.hasNext(); ) {
            AttributeNode attr = (AttributeNode) iter.next();
            if (attr.getName().equals(name)) return attr;
        }
        return null;
    }

}
