/**
 @author Dmitriy I. Suyasov
 @since 19.08.2005 14:37:09
 */
package dsuyasov.inetDoc.rulesZone;

import java.util.ArrayList;

public class RuleChoice extends Rule{

    private boolean invert = false;

    public RuleChoice(String string, int next, int number) throws RuleException {
        super(string, next, number);
        if (string.length() == 0)
            throw new RuleException("  :  ["+string+"] ");
        if (string.charAt(0) == '^') {
            invert = true;
            string = string.substring(1);
            object = string;
        }
        if (string.length() == 0)
            throw new RuleException("  :  ["+string+"] ");
        char ch = string.charAt(string.length()-1);
        if ((ch=='-' || ch=='\\') && ((string.length()==1) || (string.charAt(string.length() - 2) != '\\')))
            throw new RuleException("  :  ["+string+"]     [\\]  [-]");
        if (string.charAt(0) == '-')
            throw new RuleException("  :  ["+string+"]      [-]");
    }

    public boolean proceed(ForwardElement element) {
        increaseTheCounter();
        results.clear();
        String input = element.getText();
        String string = (String) object;
        if (input.length() > 0) {
            char inputChar = input.charAt(input.length()-1);
            int index = 0;
            while (index<string.length()) {
                switch (string.charAt(index)) {
                    case '\\':
                        char specialChar = Rule.createSpecialChar(string.charAt(index+1));
                        if (specialChar == inputChar) {
                            setNextLinks(element);
                            return !invert;
                        }
                        string = ((index>0)?string.substring(0, index):"")+specialChar+((index+2<string.length())?string.substring(index+2):"");
                        index++;
                        break;
                    case '-':
                        if (string.charAt(index+1) == '\\')
                            string = string.substring(0, index+1)+Rule.createSpecialChar(string.charAt(index+2))+((index+3<string.length())?string.substring(index+3):"");
                        char firstChar = string.charAt(index-1);
                        char secondChar = string.charAt(index+1);
                        if ((firstChar <= inputChar) && (inputChar <= secondChar)) {
                            setNextLinks(element);
                            return !invert;
                        }
                        index += 2;
                        break;
                    default:
                        char ch = string.charAt(index);
                        if (ch == inputChar) {
                            setNextLinks(element);
                            return !invert;
                        }
                        index++;
                        break;
                }
            }
            if (invert) {
                ArrayList list = new ArrayList();
                input = input.substring(0, input.length()-1);
                if (!counterMore())
                    list.add(new ForwardElement(getRuleNumber(), input, element.getResult(), element.addToHistory(new Object[] {new Integer(Rule.CHOICE), object, element.getText()})));
                if (!counterLess())
                    list.add(new ForwardElement(nextStep.getNext(), input, element.getResult(), element.addToHistory(new Object[] {new Integer(Rule.CHOICE), object, element.getText()})));
                results.addAll(list);
            }
        }
        if (this.start.intValue() == 0)
            results.add(new ForwardElement(nextStep.getNext(), input, element.getResult(), element.getHistory()));
        return invert;
    }

    public String getStartPoint() {
        return null;
    }

    private void setNextLinks(ForwardElement element) {
        if (!invert) {
            ArrayList list = new ArrayList();
            String text = element.getText();
            text = text.substring(0, text.length()-1);
            if (!counterMore())
                list.add(new ForwardElement(getRuleNumber(), text, element.getResult(), element.addToHistory(new Object[] {new Integer(Rule.CHOICE), object, element.getText()})));
            if (!counterLess())
                list.add(new ForwardElement(nextStep.getNext(), text, element.getResult(), element.addToHistory(new Object[] {new Integer(Rule.CHOICE), object, element.getText()})));
            results.addAll(list);
        }
        if (this.start.intValue() == 0)
            results.add(new ForwardElement(nextStep.getNext(), element.getText(), element.getResult(), element.getHistory()));
    }

    public String toString() {
        return "{ CHOISE ["+object+"] }";
    }

}
