/**
 @author Dmitriy Suyasov
 @since 10.10.2005 10:02:19
 */
package dsuyasov.inetDoc.aho;

public class Tree {

    private TreeElement root, element;

    public Tree() {
        root = new TreeElement(null);
        root.setText("()");
        element = root;
    }

    public void fromTheTop() {
        element = root;
    }

    public TreeElement createAChild() {
        TreeElement child = new TreeElement(element);
        element.setLink(child);
        element = child;
        return child;
    }

    public TreeElement gotoParent() {
        element = element.getParent();
        return getCurrentElement();
    }

    public TreeElement gotoRoot() {
        element = root;
        return getCurrentElement();
    }

    public TreeElement gotoLastChild() throws Exception {
        if (element.getLinkSize() == 0)
            throw new Exception("    ");
        element = element.getLink(element.getLinkSize() - 1);
        return getCurrentElement();
    }

    public TreeElement gotoChild(int index) throws Exception {
        if (element.getLinkSize() <= index)
            throw new Exception("       ["+index+"]");
        element = element.getLink(index);
        return getCurrentElement();
    }

    public TreeElement getCurrentElement() {
        return element;
    }

}
