/**
 @author Dmitriy Suyasov
 @since 10.10.2005 10:05:13
 */
package dsuyasov.inetDoc.aho;

import java.util.ArrayList;

public class TreeElement {

    private String text;
    private ArrayList link;
    private TreeElement parent;

    public TreeElement(TreeElement parent) {
        link = new ArrayList();
        text = "";
        this.parent = parent;
    }

    public TreeElement(TreeElement parent, ArrayList links, String text) {
        this.link = new ArrayList(links);
        this.text = text;
        this.parent = parent;
    }

    public void setText(String text) {
        this.text = text;
    }

    public void addToText(String text) {
        this.text += text;
    }

    public String getText() {
        return this.text;
    }

    public int getLinkSize() {
        return link.size();
    }

    public ArrayList getLinks() {
        return link;
    }

    public TreeElement getLink(int index) {
        return (TreeElement) link.get(index);
    }

    public void setLink(TreeElement element) {
        link.add(element);
    }

    public TreeElement getParent() {
        return parent;
    }

}
