/*@java
 @Created by Dmitriy I. Suyasov
 @Date 31.03.2005
 @Time 12:28:04
 */
package dsuyasov.inetDoc.main;

import dsuyasov.inetDoc.functionality.*;
import dsuyasov.inetDoc.automat.*;
import dsuyasov.inetDoc.rulesZone.*;

import java.util.ArrayList;
import java.util.Stack;
import java.util.Iterator;
import java.util.AbstractList;
import java.awt.*;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

public class Main {
    /*@
          
        @param args   
    */
    public static void main(String[] args) {

        /*//      
        if (args.length == 0) {
            Log.getLogger().out(InetDocConstant.EMPTY_PROGRAM_OUT);
            return;
        }

        Log.getLogger().automat("  ");

        //  
        for (int iLoop = 0; iLoop < args.length; iLoop++)
            CommonVariables.getInstance().arguments.add(args[iLoop]);

        //   
        AutomatMain automatMain = new AutomatMain(0);

        //   
        automatMain.work();

        Log.getLogger().automat("  ");*/


//        testMassRuleProcessor();
//        testAutomatAttributeFinder();
//          testHTMLResolver();
//        testTemplateFiller();
//        testProcessArgumentAutomat();

        AutomatMain automatMain = new AutomatMain();
        automatMain.startAutomat(args);
//        testRuleBuilder();

    }

    private static void testProcessArgumentAutomat() {
        String[] list = new String[] {"-o","ll.txt","doc"};
        AutomatArgumentProcessor automat = new AutomatArgumentProcessor();
        automat.startAutomat(list);
        int a = 1;
    }

    private static void testTemplateFiller() {
        try {
            ArrayList types = new ArrayList();
            types.add("html");
            Template template = new Template(types, "template_html.xml");
            CommonVariables cv = CommonVariables.getInstance();
            cv.setSourceDirectory("d:\\temp\\1\\bachelor\\inetDocPlus\\doc");
            AutomatAttributeFinder aaf = new AutomatAttributeFinder();
            aaf.startAutomat(template, "d:\\temp\\1\\bachelor\\inetDocPlus\\doc\\test.html");
            int a = 1;

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private static void testHTMLResolver() {
//        try {
//            DocumentBuilder docB = DocumentBuilderFactory.newInstance().newDocumentBuilder();
//            Document doc = docB.parse("test_template.html");
//
//            int a =4;
//        } catch(Exception e) {
//            e.printStackTrace();
//        }
        try {
            ArrayList types = new ArrayList();
            types.add("html");
            Template template = new Template(types, "template_html.xml");
            AutomatAttributeFinder automat2 = new AutomatAttributeFinder();
            automat2.startAutomat(template, "test.html");

            AutomatTemplateParser automat = new AutomatTemplateParser();
            automat.startAutomat("test_template.html", "inetDoc");
            AutomatTemplateFiller filler = new AutomatTemplateFiller();
            filler.startAutomat(automat.document, new PageDepository(automat2.page));

            int a =1;
        } catch (Exception e) {
            e.printStackTrace();
        }


        int a = 1;
    }

    private static void testMassRuleProcessor() {
        try {
            DocumentBuilder docB = DocumentBuilderFactory.newInstance().newDocumentBuilder();
            Document doc = docB.parse("test.xml");
            Node node = doc.getElementsByTagName("rules").item(0);
            RulesStarter rs = new RulesStarter(node, null);
            rs = addStringToRulesStarter(rs, "<!--@bloc ");
            //RuleProcessor rp = new RuleProcessor(10);
            MassRulesProcessor mrp = new MassRulesProcessor();
            mrp.startAutomat(rs);
            //rp.startAutomat(rs, "<!--@bloc ");
            //rs.startAutomat("<!--@bloc ");
    //        System.out.println(">>> "+rs);
            System.out.println("Result: "+rs.ruleNumber+" "+rs.resultString+" "+mrp.rulesSuccessed);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private static void testAutomatAttributeFinder() {
        try {
            ArrayList types = new ArrayList();
            types.add("html");
            Template template = new Template(types, "template_html.xml");
            AutomatAttributeFinder automat = new AutomatAttributeFinder();
            automat.startAutomat(template, "test.html");
            int a =1;
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private static void testRuleBuilder() {
        String str = "a";

        AutomatSintaxRuleAnalyser automat = new AutomatSintaxRuleAnalyser();
        automat.startAutomat("ab?a*", false);
        Rule rule = (Rule) automat.ruleBuilder.getResult();
        System.out.println("Result of ["+str+"]: "+rule.proceed(str));
        System.out.println("Error:"+ automat.ERROR);
    }

    private static RuleStarter getRule(RulesStarter rs, String name) {
        for (Iterator iter = rs.rules.iterator(); iter.hasNext(); ) {
            RuleStarter r = (RuleStarter) iter.next();
            if (r.getName().equals(name)) return r;
        }
        return null;
    }

    private static RulesStarter addStringToRulesStarter(RulesStarter rs, String str) {
        for (int iLoop = 0; iLoop < str.length(); iLoop++)
            rs.addCharToStringStack(str.charAt(iLoop));
        return rs;
    }

}