/**
 @author Dmitriy I. Suyasov
 @since 05.09.2005 13:54:18
 */
package dsuyasov.inetDoc.xml;

public abstract class Node {

    public static final int DOCUMENT_NODE = 0;
    public static final int ELEMENT_NODE = 1;
    public static final int TEXT_NODE = 2;
    public static final int ATTRIBUTE_NODE = 3;

    protected String name;
    protected String value;
    protected NodeList childNodes;
    protected Attributes attributes;

    public Node() {
    }

    public abstract String getName();
    public abstract String getValue();
    public abstract int getType();
    public abstract NodeList getChildNodes();
    public abstract Attributes getAttributes();
    public abstract void addNode(Node node);

    public String toString() {
        return getValue();
    }

}
